<%@ page import="org.jbpm.JbpmConfiguration,
                 java.util.Properties,
                 net.sf.hibernate.cfg.Environment,
                 org.logicalcobwebs.proxool.ProxoolFacade,
                 net.sourceforge.jtds.jdbc.Driver,
                 net.sf.hibernate.dialect.SQLServerDialect,
                 net.sf.hibernate.connection.ProxoolConnectionProvider,
                 net.sf.hibernate.cache.HashtableCacheProvider"%>
<%
  Object appLoaded = application.getAttribute("appLoaded");
  if (appLoaded==null) {

    /**
     * YOU MUST CONFIGURE THIS PART - BEGIN
     */
    String driverClass = net.sourceforge.jtds.jdbc.Driver.class.getName();
    String driverUrl = "jdbc:jtds:sqlserver://oldb01.open-lab.com:1433/jbpm_test";
    String dialect = SQLServerDialect.class.getName();
    String dbUserName = "sa";
    String dbUserPsw = "";
    /**
     * YOU MUST CONFIGURE THIS PART - END
     */

    String POOL_ALIAS = "pool";
    String url = "proxool." + POOL_ALIAS + ":" + driverClass + ":" + driverUrl;

    Properties proxoolInfo = new Properties();
    proxoolInfo.setProperty("maximum-connection-count", "15");
    proxoolInfo.setProperty("statistics", "5m,1d");
    proxoolInfo.setProperty("user", dbUserName);
    proxoolInfo.setProperty("password", dbUserPsw);
    ProxoolFacade.registerConnectionPool(url, proxoolInfo);

    Properties hibInfo = new Properties();
    hibInfo.setProperty(Environment.QUERY_SUBSTITUTIONS,"true 'Y', false 'N'");
    hibInfo.setProperty(Environment.DIALECT,dialect);
    hibInfo.setProperty(Environment.MAX_FETCH_DEPTH,"2");
    hibInfo.setProperty(Environment.USE_STREAMS_FOR_BINARY,"true");
    hibInfo.setProperty(Environment.STATEMENT_BATCH_SIZE,"50");
    hibInfo.setProperty(Environment.PROXOOL_POOL_ALIAS,POOL_ALIAS);
    hibInfo.setProperty(Environment.PROXOOL_EXISTING_POOL,"true");
    hibInfo.setProperty(Environment.CONNECTION_PROVIDER,ProxoolConnectionProvider.class.getName());
    hibInfo.setProperty(Environment.CACHE_PROVIDER,HashtableCacheProvider.class.getName());
    hibInfo.setProperty(Environment.USE_REFLECTION_OPTIMIZER,"true");
    hibInfo.setProperty(Environment.USE_QUERY_CACHE,"true");
    hibInfo.setProperty(Environment.ISOLATION,"2");

    JbpmConfiguration.configure(hibInfo);

    application.setAttribute("appLoaded",new Object());
  }
%>
<jsp:include page="partHeader.jsp" />
<p align="center"> <big><big><b>The simplest possible jbpm jsp administration and client</b></big></big><br><br>

<big><a href="backoffice/deployList.jsp">backoffice</a>&nbsp;&nbsp;<a href="client.jsp">client</a><br><br></big>
</p>
<p>
Hi,
  this is the simplest possible jbpm jsp administration and client. We've put it together in order to learn to use jbpm.<br>
In this pure jsp form, it is very simple to deploy, easy to read, but yet quite powerful.<br><br>

How to deploy this application:<br>
1. configure the properties above (of the index.jsp source), for an EXISTING database<br>
2. eventually put in WEB-INF/lib the additional jar for the db driver<br>
3. put it as webapp in tomcat, resin or wherever;<br><br>

Features:<br><br>
- it will automagically create the tables required.<br>
- there are several jars in the libs because of hibernate's persistence; apart from this the only required is jbpm-core.jar<br>
- it covers the full cycle, from deploy to instance to navigation of the fluxes<br>
- sorts the nodes of a definition<br>
- you can make the flow step by being any swimlane which is wonderful for testing<br>
- supports milestones<br>
- logs browser<br>
<br><br>

We found it very useful to implement EmptyActorAssignmentHandler as follows (it
is not required for this app to work);<br>
this implementation permits to use directly swimlanes as actors.<br>
</FONT><PRE>
<FONT style="font-family:monospaced;">
public class SmsActorAssignmentHandler implements AssignmentHandler, Configurable {

  public String selectActor(AssignmentContext assignerContext) {
    return assignerContext.getToken().getState().getSwimlane().getName();
  }

  public void configure(String configuration) {
    // DO NOTHING
  }
}
</FONT>
</PRE><font face="arial">

You may freely use the code, as in LGPL contracts; credits would be kind.<br>

<p>We hope it will be useful to someone. Give feedback (on jbpm forums)!</p>
<p>Regards,</p>
<p>Pietro Polsinelli <a href="mailto:ppolsinelli@open-lab.com">ppolsinelli@open-lab.com</a><br>
 Roberto Bicchierai <a href="mailto:rbicchierai@open-lab.com">rbicchierai@open-lab.com</a></p>

<jsp:include page="partFooter.jsp" />